Draft OrthoArray/ru

From FreeCAD Documentation
Revision as of 09:12, 25 August 2020 by FuzzyBot (talk | contribs) (Updating to match new version of source page)

Draft OrthoArray

Menu location
Modification → Array tools → Array
Workbenches
Draft
Default shortcut
None
Introduced in version
0.19
See also
Draft PolarArray, Draft CircularArray, Draft PathArray, Draft PathLinkArray, Draft PointArray, Draft Clone

Описание

The Draft OrthoArray tool creates an orthogonal (3-axes) array from a selected object.

This tool can be used on any object that has a Part TopoShape, meaning 2D shapes created with the Draft Workbench, but also 3D solids created with other workbenches, for example, Part, PartDesign, or Arch. It can also create App Links instead of simple copies.

This command deprecates the previously existing Array as well as the short lived LinkArray tools.

Orthogonal array from a solid object.

Использование

  1. Select the object that you wish to duplicate.
  2. Press the OrthoArray button. If no object is selected, you will be invited to select one.
  3. The task panel is launched, where you can select the number of elements in each X, Y, Z direction; and the interval between each created element.
  4. You can click on the 3D view to set up all the numbers and intervals, and complete the command. Otherwise, just press Enter or the OK button to complete the operation.

Notes

  • Each element in the array is an exact clone of the original object, but the entire array is considered a single unit in terms of properties and appearance.
  • This command creates the same parametric "Array" object as the one created with the PolarArray and CircularArray tools. Therefore, the array can be converted to orthogonal, polar, or circular by changing its ДанныеArray Type property.

Options

These are the options displayed in the task panel.

  • Number of elements: the elements in the X, Y, and Z directions. A copy of the original object is always produced, so this number must be at least 1 in every direction.
  • X intervals: the values of displacement for the copies in the X direction. To create strictly rectangular arrays, the Y and Z values should be zero (x, 0, 0).
  • Y intervals: the values of displacement for the copies in the Y direction. To create strictly rectangular arrays, the X and Z values should be zero (0, y, 0).
  • Z intervals: the values of displacement for the copies in the Z direction. To create strictly rectangular arrays, the X and Y values should be zero (0, 0, z).
  • Reset X, Y, Z: it resets the interval vectors to a rectangular displacement, that is (x, 0, 0), (0, y, 0), and (0, 0, z).
  • Fuse: if it is checked, the resulting objects in the array will fuse together if they touch each other. This only works if Link array is unchecked.
  • Link array: if it is checked, the resulting array will be a "Link array". This array internally uses App Link objects, so it is more efficient when handling many copies of complex shapes. However, in this case, the objects cannot be fused together.
  • Press Esc or the Cancel button to abort the current command.

Note: if a Link array is created, this object cannot be converted to a regular array. And similarly, a regular array cannot be converted to a Link array. Therefore, you must choose the type of array that you want at creation time.

Properties

An OrthoArray is derived from a Part Feature (Part::Feature class), therefore it shares all the latter's properties. In addition to the properties described in Part Feature, the OrthoArray has the following properties in the property editor.

Objects

  • ДанныеArray Type (Enumeration): specifies the type of array to create, "ortho", "polar", or "circular".
  • ДанныеAxis Reference (LinkGlobal): specifies the object and edge that can be used as reference for polar and circular arrays; for example, it can be the edge of a Wire or a PartDesign DatumLine. If this property exists, it overrides both ДанныеAxis and ДанныеCenter, for polar and circular arrays.
  • ДанныеBase (Link): specifies the object to duplicate in the array.
  • ДанныеFuse (Bool): it defaults to false; if it is true, and the copies intersect with each other, they will be fused together into a single shape. This only works if the initial array was not a "Link array".

Orthogonal array

  • ДанныеInterval X (VectorDistance): a vector specifying the interval between each copy on the X axis.
  • ДанныеInterval Y (VectorDistance): a vector specifying the interval between each copy on the Y axis.
  • ДанныеInterval Z (VectorDistance): a vector specifying the interval between each copy on the Z axis.
  • ДанныеNumber X (Integer): the number of copies on the X direction. The ДанныеBase object counts as one copy; it must be at least 1.
  • ДанныеNumber Y (Integer): the number of copies on the Y direction.
  • ДанныеNumber Z (Integer): the number of copies on the Z direction.

Polar/circular array

  • ДанныеAxis (Vector): the axis direction around which the elements in a polar or circular array are created.
  • ДанныеCenter (VectorDistance): specifies the center point of the polar or circular array. The ДанныеAxis passes through this point. For circular arrays, the ДанныеCenter specifies an offset from the ДанныеPlacement of the ДанныеBase object.

Polar array

  • ДанныеAngle (Angle): specifies the aperture of the circular arc to cover with copies; use 360 to cover an entire circle.
  • ДанныеInterval Axis (VectorDistance): distance and orientation of each copy in ДанныеAxis direction.
  • ДанныеNumber Polar (Integer): number of copies in the polar direction.

Circular array

  • ДанныеNumber Circles (Integer): the number of circular layers to create. The ДанныеBase object counts as one layer; it must be at least 1.
  • ДанныеRadial distance (Distance): the distance between circular layers.
  • ДанныеSymmetry (Integer): a number that indicates the symmetry lines in the circular layers. This number changes the distribution of the objects and making it very large may eliminate the more central layers.
  • ДанныеTangential Distance (Distance): the distance between copies in the same circular layer.

Link arrays

In addition to the previous properties, these properties only appear when the array is created as a Link array.

Objects

  • ДанныеCount (Integer): (read-only) it is the total number of objects in the array including the original object. This property is read-only as the value depends on the other "Number" properties, whether they are orthogonal, polar, or circular.
  • ДанныеExpand Array (Bool): if it is true, the individual App Link objects will be available to select in the tree view.

Link

  • ДанныеScale (Float): the scale factor of the entire array.
  • ДанныеScale List (VectorList): a list of N-vectors determining the individual scaling factor of each of the N-elements in the array, where N is ДанныеCount.
  • ДанныеLink Transform (Bool): if it is false it can override the linked object's placement.

Notes

The "Number" properties, whether for orthogonal, polar, or circular arrays, includes the original object, so this value must be at least one.

An interval is not a simple distance, but a vector (x, y, z). If more than one value is non-zero, the copy will be created in the main direction, but will also be displaced in the other non-zero directions.

For example, if ДанныеInterval X is (2 m, 1 m, 1 m), and ДанныеNumber X is 3, it will create 3 copies in the X direction; the first copy will be at the original position, the second will be displaced 2 m on X, 1 m on Y, and 1 m on Z; the third copy will be displaced 4 m on X, 2 m on Y, and 2 m on Z. Each array element will be moved slightly to one side (Y direction) and up (Z direction) beside the main X direction.

The ДанныеInterval Axis property works in the same way. If the original shape lies on the XY plane, creating a polar array with ДанныеInterval Axis (0, 0, z) allows you to make spiral arrangements, as each copy will be moved a z distance.

Configuration of individual Link objects

Normally, App Link objects are intended to be exact copies of their ДанныеLinked Object. However, there is a pending feature that will allow configuring individual properties of select App Link copies; this could be useful for Link Arrays. This feature is called a "configuration table".

Scripting

Смотри так же: Draft API и Основы написания скриптов FreeCAD.

The OrthoArray tool can be used in macros and from the Python console by using the following function.

Older call:

array = makeArray(baseobject, xvector, yvector, zvector, xnum, ynum, znum, use_link=False)

New call:

array = make_ortho_array(base_object,
                         v_x=App.Vector(10, 0, 0), v_y=App.Vector(0, 10, 0), v_z=App.Vector(0, 0, 10),
                         n_x=2, n_y=2, n_z=1,
                         use_link=True)
array = make_ortho_array2d(base_object,
                           v_x=App.Vector(10, 0, 0), v_y=App.Vector(0, 10, 0),
                           n_x=2, n_y=2,
                           use_link=True)
  • Creates an "Array" object from the base_object.
    • Instead of a reference to an object, base_object can also be the Label (string) of an object existing in the current document.
    • The vectors v_x, v_y, and v_z determine the distance between the base points of each copy, in the X, Y, and Z directions; and n_x, n_y, and n_z are the number of copies in the respective direction.
    • If use_link is True, the type of array created will be a Link array, whose elements are App Link instances instead of simple copies.
    • make_ortho_array2d ignores the Z component, so the result is going to be a 2D array in the XY plane.
array = make_rect_array(base_object,
                        d_x=10, d_y=10, d_z=10,
                        n_x=2, n_y=2, n_z=1,
                        use_link=True)
array = make_rect_array2d(base_object,
                          d_x=10, d_y=10,
                          n_x=2, n_y=2,
                          use_link=True)
  • The _rect_ variants ignore the off-diagonal components of the v_x, v_y, and v_z vectors, so the arrays will be completely rectangular; the distance between the elements is determined by d_x, d_y, and d_z.

Пример:

import FreeCAD as App
import Draft

doc = App.newDocument()

rect = Draft.make_rectangle(1500, 500)
v_x = App.Vector(1600, 0, 0)
v_y = App.Vector(0, 600, 0)

array = Draft.make_ortho_array2d(rect, v_x, v_y, 3, 4)
doc.recompute()

Scripting, non-parametric array

When using the OrthoArray tool, a parametric "Array" object is created. This can be scripted as described in the previous section.

However, to obtain standalone copies of the base object, the simple Draft.array function can be used. This will create simple copies, not a new parametric object.

To create a rectangular array, use it like this:

array_list = array(objectslist, xvector, yvector, xnum, ynum)
array_list = array(objectslist, xvector, yvector, zvector, xnum, ynum, znum)
  • Creates an array from the objects contained in objectslist, which can be a single object or a list of objects.
    • In case of a rectangular array, xvector, yvector, and zvector determine the distance between the base points of each copy, in the X, Y, and Z directions; and xnum, ynum, and znum are the number of copies in the respective direction.
    • array_list is returned with the new copies. It is either a single object or a list of objects, depending on the input objectslist.

This function internally uses Draft.move() with copy=True.

Example:

import FreeCAD as App
import Draft

doc = App.newDocument()

rect = Draft.make_rectangle(1500, 500)
v_x = App.Vector(1600, 0, 0)
v_y = App.Vector(0, 600, 0)

array = Draft.array(rect, v_x, v_y, 3, 4)
doc.recompute()